\begin{exercise}{3.3}
  I've run a Ridge Regression and a LASSO on the Boston dataset, using \texttt{MEDV} as output value.

  In Figure~\ref{fig:3.3mse}~(a)~and~(b) we can see the trend of MSE of LASSO and Ridge respectively. The values of \(\lambda\) varies between the regime where there is no constraint to the one where the constraints are so strong that all coefficients are negligible. In both situation the training error monotonically increases, while the test error reach a minimum for a non null \(\lambda\), although in Ridge Regression this is much more evident.
  \begin{figure}
    \centering
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex3/errors-lasso.pdf}
      \caption{}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex3/errors-ridge.pdf}
      \caption{}
    \end{subfigure}
    \caption{mean squared error of the regression using LASSO (a) and Ridge Regression (b), for different values of the constrain \(\lambda\).}
    \label{fig:3.3mse}
  \end{figure}
  
  In Figure~\ref{fig:3.3coeff}~(a)~and~(b) shows the coefficients of the regressions. We can see that they change from the regime with no constraints to the one where they are all zeros, but the transition is not monotonic.   
  \begin{figure}
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex3/coeff-lasso.pdf}
      \caption{}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex3/coeff-ridge.pdf}
      \caption{}
    \end{subfigure}
    
    \caption{coefficients of the regression using LASSO (a) and Ridge Regression (b), for different values of the constrain \(\lambda\).}
    \label{fig:3.3coeff}
  \end{figure} 
  
  As one may expect, although the curves have nearly the same trend with different model, the curves produced by the Ridge Regression are smoother than the ones produced by LASSO.
  
  \pythoncode{\RootPathSheetThree/ex3/code.py}
\end{exercise}